﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace ConsoleTestSimulIO
{
    class Program
    {
        static Lavatrice.FrmLavatrice fLavatrice;

        static gamon.IO.Digital.SimulIO IO;

        private static void Mostra()
        {   // dalla .Show() il form non esce mai in questo thread

            fLavatrice = new Lavatrice.FrmLavatrice();
            IO = (gamon.IO.Digital.SimulIO)fLavatrice.frmDigitalIO.Hardware;
            fLavatrice.Show();
        }

        static short portIn = 0;   // primi 8 bit di I/O (0 .. 7)
        static short portOut1 = 1; // secondi 8 bit di I/O (8 .. 15)
        static short portOut2 = 2; // terzi 8 bit di I/O (16 .. 23)

        static void Main(string[] args)
        {
            // DA NON MODIFICARE: inizio
            // fa partire il sistema simulato
            Thread t1 = new Thread(Mostra);
            t1.Start();
            Thread.Sleep(3000); // attende per dare tempo all'altro thread di inizializzare tutto
            // DA NON MODIFICARE: fine

            // spegniamo tutto, just in case..
            IO.Out(portOut1, 0);
            IO.Out(portOut2, 0);

            // attesa che accendano la lavatrice: polling su bit accensione lavatrice
            while ((IO.In(portIn) & 0x20)==0) ; // controlla se il bit viene acceso

            int nBottoniera = IO.In(portIn) & 3; // considera solo i DUE bit meno significativi
            switch (nBottoniera)
            {
                case 0: // prelavaggio
                    {
                        prelavaggio();
                        lavaggio();
                        risciacquo();
                        centrifuga(); // farla solo se il bottone centrifuga è ON
                        break;
                    }
                case 1: // lavaggio
                    {
                        lavaggio();
                        risciacquo();
                        centrifuga(); // farla solo se il bottone centrifuga è ON
                        break;
                    }
                //TODO completare: aggiungere: 
                //      lavaggio, che fa solo lavaggio e centrifuga
                //      centrifuga, che fa solo la centrifuga, ANCHE SE il bottone centrifuga è OFF
            }
            // spegni tutto per lasciare il sistema in condizione nota
            //TODO
        }

        private static void prelavaggio()
        {
            // prelavaggio a freddo: non deve riscaldare l'acqua
            // prende l'acqua dalla vasca del prelavaggio
            
            // mascheramento con OR per accendere il bit 13 (sesto bit del secondo port) 
            IO.Out(portOut1,0x20);

            // caldo (solo per prova)
            IO.Out(portOut1, (byte)(IO.In(portOut1) | 0x80));

            // polling sul livello alto (bit 5): 
            while ((IO.In(portIn) & 0x10) == 0) ;
            // spegnere il bit 13: 
            IO.Out(portOut1, (byte)(IO.In(portOut1) & 0xDF));

            //TODO attende che l'acqua arrivi fino al livello superiore
            //TODO chiude l'acqua
            //TODO gira piano in senso orario per 1 s
            // ATTENDE 1/2 s
            //TODO gira piano in senso ANTIorario per 1 s
            //TODO ripete i giramenti per tre volte
            
            // scarica l'acqua fino a che il livello non scende sotto il livello minimo
            // TODO da fare! 
        }

        private static void lavaggio()
        {
            // prelavaggio a freddo: riscalda l'acqua fino a termostato
            // simile a prelavaggio, solo che scalda contemporaneamente l'acqua,
            // spegnendo il riscaldatore quando la temperatura diventa troppo alta, 
            // ripete i giramenti per 6 volte e gira per 3 s invece di 1 s
        }

        private static void risciacquo()
        {
            // identico a prelavaggio, ma prende l'acqua dalla vasca del risciaquo
            //TODO fare (N.B. E' VIETATO IL COPIA E INCOLLA DAL PRELAVAGGIO, usare un metodo)
        }

        private static void centrifuga()
        {
           // come prelavaggio, solo che la velocità è alta e non bassa. 
        }
    }
}
